grk::TileComponent Struct Reference

`#include <TileComponent.h>`

Inheritance diagram for grk::TileComponent:

## Public Member Functions

| TileComponent ()
| ~TileComponent ()
bool | allocRegionWindow (uint32_t numres, bool truncatedTile)
bool | canCreateWindow (grk_rect32 unreducedTileCompOrImageCompWindow)
void | createWindow (grk_rect32 unreducedTileCompOrImageCompWindow)
void | dealloc (void)
bool | init (TileProcessor *tileProcessor, grk_rect32 unreducedTileComp, uint8_t prec, TileComponentCodingParams *tccp)
| Initialize tile component in unreduced tile component coordinates (tile component coordinates take sub-sampling into account).
bool | subbandIntersectsAOI (uint8_t resno, eBandOrientation orient, const grk_rect32 *aoi) const
TileComponentWindow< int32_t > * | getWindow () const
bool | isWholeTileDecoding ()
ISparseCanvas * | getRegionWindow ()
void | postProcess (int32_t *srcData, DecompressBlockExec *block)
void | postProcessHT (int32_t *srcData, DecompressBlockExec *block, uint16_t stride)
Public Member Functions inherited from grk::grk_rect< uint32_t >
| grk_rect (uint32_t origin_x0, uint32_t origin_y0, uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (const grk_rect &rhs)
| grk_rect (const grk_rect *rhs)
| grk_rect (void)
virtual | ~grk_rect ()=default
grk_rect< uint32_t > & | setOrigin (uint32_t origx, uint32_t origy, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > &rhs, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > *rhs, bool absolute)
grk_rect< uint32_t > & | toRelative (void)
grk_rect< uint32_t > & | toAbsolute (void)
virtual void | print (void) const
std::string | boundsString () const
bool | valid (void) const
bool | empty (void) const
bool | contains (grk_pt< uint32_t > pt)
bool | contains (uint32_t x, uint32_t y)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > &rhs)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > *rhs)
bool | operator== (const grk_rect< uint32_t > &rhs) const
void | setRect (grk_rect< uint32_t > *rhs)
void | setRect (grk_rect< uint32_t > rhs)
grk_rect< uint32_t > | scaleDownCeil (uint32_t den) const
grk_rect< uint32_t > | scaleDownCeil (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scale (uint32_t scalex, uint32_t scaley) const
grk_rect< uint32_t > | scaleDown (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scaleDownPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | scaleDownPow2 (grk_pt< uint32_t > pow) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t power) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > *rhs) const
bool | isContainedIn (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > &rhs) const
grk_rect< uint32_t > & | clip_IN_PLACE (const grk_rect< uint32_t > &rhs)
bool | nonEmptyIntersection (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > &rhs) const
uint64_t | area (void) const
uint32_t | width () const
uint32_t | height () const
grk_line< uint32_t > | dimX () const
grk_line< uint32_t > | dimY () const
grk_rect< uint32_t > | pan (int64_t x, int64_t y) const
grk_rect< uint32_t > & | pan_IN_PLACE (int64_t x, int64_t y)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, grk_rect< uint32_t > bounds)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, grk_rect< uint32_t > bounds)
uint32_t | parityX (void) const
uint32_t | parityY (void) const

## Public Attributes

Resolution * | resolutions_
uint8_t | numresolutions
uint8_t | numResolutionsToDecompress
std::atomic< uint8_t > | highestResolutionDecompressed
Public Attributes inherited from grk::grk_rect< uint32_t >
bool | absoluteCoordinates
uint32_t | origin_x0
uint32_t | origin_y0
uint32_t | x0
uint32_t | y0
uint32_t | x1
uint32_t | y1

## Private Member Functions

template<typename F >
void | postDecompressImpl (int32_t *srcData, DecompressBlockExec *block, uint16_t stride)

## Private Attributes

ISparseCanvas * | regionWindow_
bool | wholeTileDecompress
bool | isCompressor_
TileComponentWindow< int32_t > * | window_
TileComponentCodingParams * | tccp_

## Constructor & Destructor Documentation

## TileComponent()

grk::TileComponent::TileComponent | ( |  | ) |

## ~TileComponent()

grk::TileComponent::~TileComponent | ( |  | ) |

References dealloc(), grk::grk_read(), numresolutions, grk::Subband::precincts, resolutions_, and grk::Resolution::tileBand.

## Member Function Documentation

## allocRegionWindow()

bool grk::TileComponent::allocRegionWindow | ( | uint32_t | numres,
|  | bool | truncatedTile
| ) |  |

References grk::grk_rect< T >::clip(), grk::TileComponentWindow< T >::getBandWindowPadded(), grk::grk_read(), grk::grk_rect< T >::height(), regionWindow_, resolutions_, grk::grk_rect< T >::scaleDownPow2(), grk::Resolution::tileBand, grk::grk_rect< T >::width(), and window_.

Referenced by grk::TileProcessor::decompressT2T1().

## canCreateWindow()

bool grk::TileComponent::canCreateWindow | ( | grk_rect32 | unreducedTileCompOrImageCompWindow | ) |

References grk::GRK_ERROR(), grk::grk_read(), numresolutions, and resolutions_.

## createWindow()

void grk::TileComponent::createWindow | ( | grk_rect32 | unreducedTileCompOrImageCompWindow | ) |

References dealloc(), grk::grk_read(), isCompressor_, numresolutions, numResolutionsToDecompress, grk::TileComponentCodingParams::qmfbid, resolutions_, tccp_, wholeTileDecompress, and window_.

## dealloc()

void grk::TileComponent::dealloc | ( | void |  | ) |

References regionWindow_, and window_.

Referenced by createWindow(), grk::TileProcessor::deallocBuffers(), and ~TileComponent().

## getRegionWindow()

ISparseCanvas * grk::TileComponent::getRegionWindow | ( |  | ) |

References regionWindow_.

## getWindow()

TileComponentWindow< int32_t > * grk::TileComponent::getWindow | ( |  | ) | const

References window_.

Referenced by grk::WaveletFwdImpl::encode_procedure(), grk::TileProcessor::isWholeTileDecompress(), grk::TileProcessor::mct_encode(), and grk::TileProcessor::mctDecompress().

## init()

bool grk::TileComponent::init | ( | TileProcessor * | tileProcessor,
|  | grk_rect32 | unreducedTileComp,
|  | uint8_t | prec,
|  | TileComponentCodingParams * | tccp
| ) |  |

Initialize tile component in unreduced tile component coordinates (tile component coordinates take sub-sampling into account).

References grk::BAND_ORIENT_LL, grk::TileProcessor::cp_, DEBUG_TILE_COMPONENT, grk::floordivpow2(), grk::ResSimple::getBandWindow(), grk::GRK_ERROR(), grk::grk_read(), grk::TileProcessor::isCompressor(), isCompressor_, grk::TileComponentCodingParams::numresolutions, numresolutions, numResolutionsToDecompress, grk::TileComponentCodingParams::precHeightExp, grk::TileComponentCodingParams::precWidthExp, resolutions_, grk::grk_rect< T >::setRect(), grk::grk_rect< uint32_t >::setRect(), tccp_, grk::Resolution::tileBand, wholeTileDecompress, and grk::grk_rect< T >::x0.

## isWholeTileDecoding()

bool grk::TileComponent::isWholeTileDecoding | ( |  | ) |

References wholeTileDecompress.

Referenced by grk::DecompressScheduler::scheduleBlocks().

## postDecompressImpl()

template<typename F >

void grk::TileComponent::postDecompressImpl | ( | int32_t * | srcData,
|  | DecompressBlockExec * | block,
|  | uint16_t | stride
| ) |  |

private

References grk::grk_rect< uint32_t >::empty(), grk::grk_read(), grk::TileComponentWindow< T >::postProcess(), regionWindow_, grk::TileComponentWindow< T >::toRelativeCoordinates(), window_, and grk::ISparseCanvas::write().

## postProcess()

void grk::TileComponent::postProcess | ( | int32_t * | srcData,
|  | DecompressBlockExec * | block
| ) |  |

References grk::grk_read().

## postProcessHT()

void grk::TileComponent::postProcessHT | ( | int32_t * | srcData,
|  | DecompressBlockExec * | block,
|  | uint16_t | stride
| ) |  |

References grk::grk_read().

Referenced by ojph::T1OJPH::decompress(), and openhtj2k::T1OpenHTJ2K::decompress().

## subbandIntersectsAOI()

bool grk::TileComponent::subbandIntersectsAOI | ( | uint8_t | resno,
|  | eBandOrientation | orient,
|  | const grk_rect32 * | aoi
| ) |  | const

References grk::TileComponentWindow< T >::getBandWindowPadded(), grk::grk_read(), grk::grk_rect< T >::nonEmptyIntersection(), and window_.

## Member Data Documentation

## highestResolutionDecompressed

std::atomic<uint8_t> grk::TileComponent::highestResolutionDecompressed

Referenced by grk::DecompressScheduler::scheduleWavelet().

## isCompressor_

bool grk::TileComponent::isCompressor_

private

Referenced by createWindow(), and init().

## numresolutions

uint8_t grk::TileComponent::numresolutions

Referenced by canCreateWindow(), createWindow(), grk::WaveletFwdImpl::encode_procedure(), grk::TileProcessor::encodeT2(), init(), grk::TileProcessor::init(), and ~TileComponent().

## numResolutionsToDecompress

uint8_t grk::TileComponent::numResolutionsToDecompress

Referenced by createWindow(), and init().

## regionWindow_

ISparseCanvas* grk::TileComponent::regionWindow_

private

Referenced by allocRegionWindow(), dealloc(), getRegionWindow(), and postDecompressImpl().

## resolutions_

Resolution* grk::TileComponent::resolutions_

Referenced by allocRegionWindow(), canCreateWindow(), grk::T2Compress::compressPacketSimulate(), createWindow(), grk::TileProcessor::decompressT2T1(), grk::WaveletFwdImpl::encode_procedure(), grk::TileProcessor::encodeT2(), init(), grk::TileProcessor::init(), grk::TileProcessor::makeLayerFeasible(), grk::TileProcessor::makeLayerFinal(), grk::TileProcessor::makeLayerSimple(), grk::TileProcessor::pcrdBisectFeasible(), grk::TileProcessor::pcrdBisectSimple(), grk::T2Decompress::processPacket(), grk::PacketParser::readData(), grk::PacketParser::readHeader(), and ~TileComponent().

## tccp_

TileComponentCodingParams* grk::TileComponent::tccp_

private

Referenced by createWindow(), and init().

## wholeTileDecompress

bool grk::TileComponent::wholeTileDecompress

private

Referenced by createWindow(), init(), and isWholeTileDecoding().

## window_

TileComponentWindow<int32_t>* grk::TileComponent::window_

private

Referenced by allocRegionWindow(), createWindow(), dealloc(), getWindow(), postDecompressImpl(), and subbandIntersectsAOI().

The documentation for this struct was generated from the following files:

- TileComponent.h
- TileComponent.cpp